<template>
    <div class="dialog-table-container sub-page-inner">
        <div class="sub-page-detail full-detail" style="width: 100%">
            <div class="flex-table" :element-loading-background="'rgba(6, 46, 106, 0.8)'" v-loading="loading">
                <div class="flex-header">
                    <el-row :gutter="20">
                        <el-col :span="8">
                            <el-select popper-class="big-search-popper" v-model="currentType" clearable
                                style="width: 100%" placeholder="请选择类型" @change="changeType">
                                <el-option v-for="item in typeOptins" :key="item.value" :label="item.label"
                                    :value="item.value">
                                </el-option>
                            </el-select>
                            <!-- <el-select v-model="currentType" popperClass="big-search-popper" placeholder="请选择类型"
                                @change="changeType" :popper-append-to-body="false" style="width: 100%;">
                                <el-option v-for="item in typeOptins" :key="item.value" :label="item.label"
                                    :value="item.value">
                                </el-option>
                            </el-select> -->
                        </el-col>
                        <el-col :span="2">
                            <el-button type="primary" icon="el-icon-download" :loading="exportLoading"
                                @click="exportData">导出</el-button>
                        </el-col>
                    </el-row>
                    <div>
                        <div>
                            <i class="el-icon-info" style="color: #e6a23c"></i>
                            {{ this['memo' + currentType] + (currentType == 2 ? '。指标数据为错月数据（上月底）' : '') }}
                        </div>
                        <div v-if="endTime">数据截止时间： {{ endTime }}</div>
                    </div>
                </div>
                <div class="table-wrapper">
                    <el-table border :data="threeResultData" min-height="1000" style="width: 100%"
                        :cell-style="{ 'text-align': 'center', color: '#fff' }" :header-cell-style="{
                            'text-align': 'center', color: '#fff'
                        }" height="100%">
                        <!-- <el-table-column
                            type="index"
                            label="排名"
                            width="50"
                            align="center"
                            fixed="left">
                            <template slot-scope="scope">
                                <span>{{ scope.$index + 1 }}</span>
                            </template>
</el-table-column> -->
                        <template v-for="item in tableHeader">
                            <el-table-column align="center" :key="item.key" :label="item.label"
                                :label-class-name="item.type == 'parent-column' ? 'bold' : ''">
                                <el-table-column align="center" v-for="childrenCol in item.children"
                                    :key="childrenCol.key" :prop="childrenCol.key" :label="childrenCol.label"
                                    :min-width="childrenCol.width" resizable
                                    :label-class-name="childrenCol.type == 'child-type' ? 'child-bold' : 'child-normal'">
                                    <template slot-scope="scope">
                                        <span :class="childrenCol.dataType">{{ scope.row[childrenCol.key]
                                            }}</span>
                                    </template>
                                </el-table-column>
                            </el-table-column>
                        </template>
                    </el-table>
                </div>
                <!-- <div class="tip" v-if="threeMonth">* 注：当前数据为{{threeMonth}}月数据。</div> -->
            </div>
        </div>
    </div>
</template>

<script>
import apiList from '@/api/bigScreen/majorView.js'
import utils from '@/utils.js'
const tempArr = {
    nationFirmCity: [],
    nationFirmCounty: [],
    parkAreaCity: [],
    parkAreaCounty: [],
    gEnterpriseCity: [],
    gEnterpriseCounty: [],
    nationAssetsCity: [],
    nationAssetsCounty: [],
}
export default {
    name: 'threeAttacksOneTask',
    data() {
        return {
            loading: false,
            currentType: '1',
            typeOptins: [
                {
                    label: '国企改革攻坚',
                    value: '1',
                    key: 'nationFirm',
                },
                {
                    label: '园区开发区改革攻坚',
                    value: '2',
                    key: 'parkArea',
                },
                {
                    label: '政企分离改革攻坚',
                    value: '3',
                    key: 'gEnterprise',
                },
                {
                    label: '国有资产盘活',
                    value: '4',
                    key: 'nationAssets',
                },
            ],
            tableHeader: [],
            tableHeader1: [
                {
                    label: '国企改革攻坚',
                    key: 'a',
                    type: 'parent-column',
                    children: [
                        {
                            label: '排名',
                            key: 'gqRank',
                            dataType: 'gq',
                        },
                        {
                            label: '市属\n重点国企',
                            key: 'gqUnitName',
                            dataType: 'gq',
                        },
                        {
                            label: '得分',
                            key: 'gqFinishRate',
                            width: 100,
                            dataType: 'gq',
                        },
                        {
                            label: '利润总额\n（万元）',
                            key: 'gqCgTotalNum',
                            width: 90,
                        },
                        {
                            label: '利润总额\n增速（%）',
                            key: 'gqCgFinishRate',
                            width: 100,
                        },
                        {
                            label: '纳入目标责任书统计的\n亏损企业总户数（户）',
                            key: 'gqJsTotalNum',
                            width: 200,
                        },
                        {
                            label: '止损减亏\n企业户数（户）',
                            key: 'gqJsFinishNum',
                            width: 140,
                        },
                        {
                            label: '止损减亏\n完成率（%）',
                            key: 'gqJsFinishRate',
                            width: 120,
                        },
                        {
                            label: '排名',
                            key: 'qxRank',
                            dataType: 'qx',
                        },
                        {
                            label: '区县',
                            key: 'qxUnitName',
                            width: 90,
                            dataType: 'qx',
                        },
                        {
                            label: '得分',
                            key: 'qxFinishRate',
                            width: 100,
                            dataType: 'qx',
                        },
                        {
                            label: '纳入目标责任书统计的\n应压减企业总户数（户）',
                            key: 'qxCgTotalNum',
                            width: 210,
                        },
                        {
                            label: '压减户数\n（户）',
                            key: 'qxCgFinishNum',
                            width: 90,
                        },
                        {
                            label: '法人压减\n完成率（%）',
                            key: 'qxCgFinishRate',
                            width: 140,
                        },
                        {
                            label: '纳入目标责任书统计的\n亏损企业总户数（户）',
                            key: 'qxJsTotalNum',
                            width: 200,
                        },
                        {
                            label: '止损减亏\n企业户数（户）',
                            key: 'qxJsFinishNum',
                            width: 140,
                        },
                        {
                            label: '止损减亏\n完成率（%）',
                            key: 'qxJsFinishRate',
                            width: 120,
                        },
                    ],
                },
            ],
            tableHeader2: [
                {
                    label: '园区开发区改革攻坚',
                    key: 'b',
                    type: 'parent-column',
                    children: [
                        {
                            label: '排名',
                            key: 'qxRank',
                        },
                        {
                            label: '区县',
                            key: 'qxUnitName',
                            type: 'child-type',
                            width: 100,
                        },
                        {
                            label: '得分',
                            key: 'qxFinishRate',
                            width: 140,
                        },
                        {
                            label: '园区开发区规上\n工业企业亩均税收增速（%）',
                            key: 'qxCgFinishRate',
                            width: 200,
                        },
                        {
                            label: '各区县签订目标责任书上设定的\n规上工业企业营业收入（亿元）',
                            key: 'qxJsTotalNum',
                            width: 240,
                        },
                        {
                            label: '实际完成\n营业收入（亿元）',
                            key: 'qxJsFinishNum',
                            width: 140,
                        },
                        {
                            label: '园区开发区规上企业\n营业收入完成率（%）',
                            key: 'qxJsFinishRate',
                            width: 240,
                        },
                    ],
                },
            ],
            tableHeader3: [
                {
                    label: '政企分离改革攻坚',
                    key: 'c',
                    type: 'parent-column',
                    children: [
                        {
                            label: '排名',
                            key: 'gqRank',
                            dataType: 'gq',
                        },
                        {
                            label: '市级部门',
                            key: 'gqUnitName',
                            type: 'child-type',
                            width: 180,
                            dataType: 'gq',
                        },
                        {
                            label: '得分',
                            key: 'gqFinishRate',
                            width: 100,
                            dataType: 'gq',
                        },
                        {
                            label: '需纳入集中统一监管的\n国有企业（全级次）\n总量（个）',
                            key: 'gqCgTotalNum',
                            width: 220,
                        },
                        {
                            label: '已纳入集中统一监管\n国有企业（全级次）\n数量（个）',
                            key: 'gqCgFinishNum',
                            width: 180,
                        },
                        {
                            label: '经营性国有\n资产集中统一\n监管比例（%）',
                            key: 'gqCgFinishRate',
                            width: 140,
                        },
                        {
                            label: '须政企分离改革\n国有企业（全级次）\n总量（个）',
                            key: 'gqJsTotalNum',
                            width: 170,
                        },
                        {
                            label: '已完成政企分离改革\n国有企业（全级次）\n数量（个）',
                            key: 'gqJsFinishNum',
                            width: 180,
                        },
                        {
                            label: '政企分离\n改革完成率\n（%）',
                            key: 'gqJsFinishRate',
                            width: 120,
                        },
                        {
                            label: '排名',
                            key: 'qxRank',
                            dataType: 'qx',
                        },
                        {
                            label: '区县',
                            key: 'qxUnitName',
                            type: 'child-type',
                            width: 90,
                            dataType: 'qx',
                        },
                        {
                            label: '得分',
                            key: 'qxFinishRate',
                            width: 100,
                            dataType: 'qx',
                        },
                        {
                            label: '需纳入集中统一监管的\n国有企业（全级次）\n总量（个）',
                            key: 'qxCgTotalNum',
                            width: 220,
                        },
                        {
                            label: '已纳入集中统一监管\n国有企业（全级次）\n数量（个）',
                            key: 'qxCgFinishNum',
                            width: 180,
                        },
                        {
                            label: '经营性国有\n资产集中统一\n监管比例（%）',
                            key: 'qxCgFinishRate',
                            width: 140,
                        },
                        {
                            label: '须政企分离改革\n国有企业（全级次）\n总量 (个)',
                            key: 'qxJsTotalNum',
                            width: 170,
                        },
                        {
                            label: '已完成政企分离改革\n国有企业（全级次）\n数量 (个)',
                            key: 'qxJsFinishNum',
                            width: 180,
                        },
                        {
                            label: '政企分离\n改革完成率\n （%）',
                            key: 'qxJsFinishRate',
                            width: 120,
                        },
                    ],
                },
            ],
            tableHeader4: [
                {
                    label: '国有资产盘活',
                    key: 'd',
                    type: 'parent-column',
                    children: [
                        {
                            label: '排名',
                            key: 'gqRank',
                            dataType: 'gq',
                        },
                        {
                            label: '单位',
                            key: 'gqUnitName',
                            type: 'child-type',
                            width: 180,
                            dataType: 'gq',
                        },
                        {
                            label: '得分',
                            key: 'gqFinishRate',
                            width: 100,
                            dataType: 'gq',
                        },
                        {
                            label: '全年盘活\n变现回收资金\n目标（亿元）',
                            key: 'gqCgTotalNum',
                            width: 140,
                        },
                        {
                            label: '已盘活变现的\n回收资金\n（亿元）',
                            key: 'gqCgFinishNum',
                            width: 130,
                        },
                        {
                            label: '存量国有资产\n盘活变现回收资金\n完成率（%）',
                            key: 'gqCgFinishRate',
                            width: 160,
                        },
                        {
                            label: '全年存量\n国有资产盘活\n目标（亿元）',
                            key: 'gqJsTotalNum',
                            width: 130,
                        },
                        {
                            label: '已盘活存量\n国有资产价值\n（亿元）',
                            key: 'gqJsFinishNum',
                            width: 130,
                        },
                        {
                            label: '盘活存量\n国有资产\n完成率（%）',
                            key: 'gqJsFinishRate',
                            width: 120,
                        },
                        {
                            label: '排名',
                            key: 'qxRank',
                            dataType: 'qx',
                        },
                        {
                            label: '区县',
                            key: 'qxUnitName',
                            type: 'child-type',
                            width: 90,
                            dataType: 'qx',
                        },
                        {
                            label: '得分',
                            key: 'qxFinishRate',
                            width: 100,
                            dataType: 'qx',
                        },
                        {
                            label: '全年盘活\n变现回收资金\n目标（亿元）',
                            key: 'qxCgTotalNum',
                            width: 140,
                        },
                        {
                            label: '已盘活变现的\n回收资金\n（亿元）',
                            key: 'qxCgFinishNum',
                            width: 130,
                        },
                        {
                            label: '存量国有资产\n盘活变现回收资金\n完成率（%）',
                            key: 'qxCgFinishRate',
                            width: 160,
                        },
                        {
                            label: '全年存量\n国有资产盘活\n目标（亿元）',
                            key: 'qxJsTotalNum',
                            width: 130,
                        },
                        {
                            label: '已盘活存量\n国有资产\n价值（亿元）',
                            key: 'qxJsFinishNum',
                            width: 130,
                        },
                        {
                            label: '盘活存量\n国有资产\n完成率（%）',
                            key: 'qxJsFinishRate',
                            width: 120,
                        },
                    ],
                },
            ],
            memo1: '根据得分排名',
            memo2: '根据得分排名',
            memo3: '根据得分排名',
            memo4: '根据得分排名',
            threeResultData: [],
            oneData: [],
            year: '',
            exportLoading: false,
            endTime: '',
            threeMonth: null
        }
    },
    beforeDestroy() {
        this.$bus.$off('changeDate')
    },
    mounted() {
        let type = this.$route.query.type
        this.tableHeader = this[`tableHeader${type}`]
        this.currentType = type
        this.getThreeData()
        this.$bus.$on('changeDate', (searchDate) => {
            this.getThreeData()
        })
    },
    created() {
        this.$emit('searchDateChange')
    },
    methods: {
        changeType(val) {
            this.tableHeader = this[`tableHeader${val}`]
            this.getThreeData()
        },
        getThreeData() {
            this.endTime = ''
            this.threeResultData = []
            this.loading = true
            let { year, month } = JSON.parse(sessionStorage.getItem('searchDate'))
            this.year = year
            let data = {
                fillMonth: month,
                fillYear: year,
                fillType: this.currentType,
            }
            apiList.getThreeOneData(data, (res) => {
                if (res) {
                    this.threeMonth = res.fillMonth === month ? null : res.fillMonth
                    this.threeResultData = res.details
                    this.endTime = res.endTime
                }
                this.loading = false
            })
        },
        exportData() {
            if (!this.threeResultData.length) {
                this.$message.warning('抱歉，暂无数据可导出！')
                return
            }
            this.exportLoading = true
            let { year, month } = JSON.parse(sessionStorage.getItem('searchDate'))
            let data = {
                fillMonth: month,
                fillYear: year,
                fillType: this.currentType,
            }
            apiList.exportThreeOneData(data, (res) => {
                if (res) {
                    this.exportLoading = false
                }
            })
        },
    },
}
</script>
<style lang="scss" scoped>
@import './table.scss';

* {
    font-size: 18PX !important;
}

::-webkit-scrollbar {
    background-color: transparent;
}

.flex-table {
    /deep/ .el-select .el-input.is-focus .el-input__inner {
        border-color: #2761ff;
    }

    .flex-header {
        display: flex;
        justify-content: space-between;
        align-items: center;

        // >div {
        //     display: flex;
        //     justify-content: start;
        //     align-items: center;
        //     gap: 20px;
        // }

        .el-row {
            width: 50%;

            /deep/input {
                font-size: 18PX;
            }
        }

        /deep/.big-search-popper {
            & .el-select-dropdown__item {
                span {
                    font-size: 16PX !important;
                }
            }
        }

        /deep/ .el-button {
            display: flex;
            align-items: center;

            i,
            span {
                font-size: 18PX;
            }
        }
    }

    // display: flex;
    width: 100%;
    height: calc(100%);

    .table-wrapper {
        width: 100%;
        height: calc(100% - 50px);
        margin-top: 10px;
    }

    // .tip {
    //     height: 40PX;
    //     line-height: 40PX;
    //     font-size: 19PX !important;
    // }

    /deep/.el-table--border th.el-table__cell.gutter:last-of-type {
        border-bottom: 1px solid rgb(39, 86, 162);
    }

    /deep/.el-table__fixed::before,
    .el-table__fixed-right::before {
        height: 0;
    }

    /deep/ thead tr th:nth-child(1) {
        background-color: #072d62 !important;
    }

    /deep/.el-table__row td:nth-child(1) {
        background-color: #072d62 !important;
    }

    /deep/.el-table ::-webkit-scrollbar {
        background-color: transparent;
    }

    /deep/.el-table--enable-row-hover .el-table__body tr:hover>td {
        background-color: rgb(39, 86, 162) !important;
    }

    /deep/.el-table__header-wrapper {
        .cell {
            display: flex;
            align-items: center;
            justify-content: center;
            font-size: 17PX !important;
            color: hsl(0, 0%, 100%);
            padding: 2px;
            line-height: 130% !important;
        }
    }

    /deep/.el-table__cell {
        .cell {
            display: flex;
            align-items: center;
            justify-content: center;
            font-size: 17PX !important;
            color: #fff;
            padding: 2px;
            padding: 0 4px;
        }
    }

    /deep/th.el-table__cell {
        .cell {
            white-space: pre;
            line-height: 130% !important;
        }
    }

    /*最外层透明*/
    /deep/.el-table,
    /deep/.el-table__expanded-cell {
        background-color: transparent !important;
    }

    /* 表格内背景颜色 */
    /deep/.el-table th,
    /deep/.el-table tr,
    /deep/.el-table td {
        background-color: transparent !important;
    }


    /deep/.el-table--border,
    /deep/.el-table--group {
        border: 1px solid rgb(39, 86, 162) !important;
        border-right: none !important;

        &:last-child {
            border: 1px solid rgb(39, 86, 162) !important;
        }
    }

    /deep/.el-table--border {
        border: 1px solid rgb(39, 86, 162) !important;
    }

    /deep/.el-table--border th {
        &:nth-last-child(2) {
            border-right: none !important;
        }
    }

    /**
改变表格内竖线颜色
 */
    /deep/.el-table--border td,
    /deep/.el-table--border th,
    /deep/.el-table__body-wrapper .el-table--border.is-scrolling-left~.el-table__fixed {
        border-right: 1px solid rgb(39, 86, 162) !important;

        &:last-child {
            border-right: none !important;
        }
    }

    /**
改变表格内行线颜色
 */
    /deep/.el-table td,
    /deep/.el-table th.is-leaf {
        border-bottom: 1px solid rgb(39, 86, 162) !important;
    }

    /deep/.el-table thead tr th {
        border-color: rgb(39, 86, 162);
    }

    /deep/.el-table--border::after {
        background: none;
    }

    /deep/.el-table::before {
        height: 0px;
    }

    /deep/.el-table--scrollable-y .el-table__body-wrapper {
        overflow-y: auto;
    }

    /deep/ .el-input__inner {
        background-color: rgba(1, 47, 115, 0.6);
        border: 1px solid #0273e9;
        color: #fff;
    }

    /deep/ .el-select-dropdown__item {
        background-color: #0d57ac !important;
        color: rgba(230, 247, 255, 0.7);

        span {
            font-size: 14px;
        }
    }

    /deep/ .el-select-dropdown__list {
        padding: 0;
    }

    /deep/ .el-select-dropdown {
        border: solid 1px #0273e9;
        background-color: rgba(1, 47, 115, 0.6);
    }

    /deep/.el-select-dropdown__item.hover,
    /deep/ .el-select-dropdown__item:hover {
        background-color: #025ec0 !important;
    }

    /deep/.el-popper[x-placement^="bottom"] .popper__arrow::after {
        border-bottom-color: #0d57ac;
    }

    /deep/.el-popper[x-placement^="bottom"] .popper__arrow {
        border-bottom-color: #0273e9;
    }

    /* 设置滚动条的样式 */
    ::-webkit-scrollbar {
        width: 10px !important; //垂直方向上的宽
        height: 14px !important; //水平方向上的宽
    }

    .gq {
        color: #3399ff !important;
    }

    .qx {
        color: #09b12d !important;
    }
}

/deep/.el-table {
    background: transparent;
    border: 1px solid rgba(2, 115, 233, 0.5);
    margin-bottom: 10px;

    ::-webkit-scrollbar-thumb {
        background-color: #034eb0 !important;
    }

    ::-webkit-scrollbar-track {
        background: #01215a !important;
    }

    ::-webkit-scrollbar {
        width: 18px !important;
        height: 18px !important;
        background: #01215a !important;
    }
}
</style>
